<template>
  <div class="container">
    <div class="row">
      <div class="col-md-3 Todo">
        <h1>TO DO LIST ONE</h1>
        <hr>
        <div v-if="!isEditing">
          <input type="text" placeholder="Enter value" v-model="todo" />
          <input type="submit" class="submit" value="add" @click="storeTodo" />
        </div>
        <div v-else>
          <input type="text" placeholder="Enter value" v-model="todo" />
          <input
            type="submit"
            class="submit"
            value="edit"
            @click="updateTodo"
          />
        </div>
        <br /><br />
        <ol>
          <li v-for="(todo, index) in todos" :key="todo">
            {{ todo }}
            <div class="btn btn-success" @click="editTodo(index, todo)">
              Edit
            </div>
            <div class="btn btn-success" @click="deleteTodo(index)">Delete</div>
          </li>
        </ol>
      </div>
      <div class="col-md-3 Todo">
        <h1>API-POST</h1>
        <hr />
        <div class="form-group">
          <label for="UserName">User Name</label>
          <input
            type="text"
            id="UserName"
            class="form-control"
            placeholder="Enter User Name"
            v-model="User.UserName"
          />
        </div>
        <div class="form-group">
          <label for="UserName">Email</label>
          <input
            type="text"
            id="Email"
            class="form-control"
            placeholder="Enter Email"
            v-model="User.Email"
          />
        </div>
        <button class="btn btn-success" type="submit" @click="submitForm">
          Send
        </button>
      </div>
      <div class="col-md-3 Todo">
        <h1>API-GET</h1>
        <hr />
        <button class="btn btn-success" @click="GetUsers">Get Users</button>
        <br /><br />
        <ul class="list-group">
          <li class="list-group-item" v-for="user in Users" :key="user.Email">
            {{ user.UserName }}-{{ user.Email }}
          </li>
        </ul>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "app",
  data() {
    return {
      selectedIndex: null,
      isEditing: false,
      todo: "",
      todos: ["one Item", "Two Item"],
      User: {
        UserName: "",
        Email: "",
      },
      Users: [],
      resource: {},
    };
  },
  methods: {
    storeTodo() {
      this.todos.push(this.todo), (this.todo = "");
    },
    editTodo(index, todo) {
      (this.todo = todo), (this.selectedIndex = index), (this.isEditing = true);
    },
    updateTodo() {
      this.todos.splice(this.selectedIndex, 1, this.todo),
        (this.isEditing = false);
      this.todo = "";
    },
    deleteTodo(index) {
      this.todos.splice(index, 1);
    },
    submitForm() {
      // console.log(this.todos);
      // this.$http.post("User.json", this.User).then(
      //   (response) => {
      //     console.log(response);
      //   },
      //   (error) => {
      //     console.log(error);
      //   }
      // );
      // this.resource.save({},this.User);
      this.resource.SaveUser(this.User)
      this.User = "";
      // alert("Send Data Now");
    },
    GetUsers() {
      this.$http
        .get("User.json")
        .then((response) => {
          return response.json();
        })
        .then((data) => {
          // console.log(data);
          const resultArray = [];
          for (let key in data) {
            resultArray.push(data[key]);
          }
          this.Users = resultArray;
          // alert("Get Data Now")
          const mutations = {
            updateValue(state, value) {
              state.value = value;
              Vue.$vToastify("Successfully updated value!");
              // OR
              this._vm.$vToastify("Successfully updated value!");
            },
          };
        });
    },
    created() {
      const customActions = {
        SaveUser: { url: "User.json", method: "POST" },
        EditUser: { url: "Car.json", method: "PUT" },
      };
      this.resource = this.$resource("User.json", {}, customActions);
    },
  },
};
</script>

<style>
.row h1 {
  background-color: aquamarine;
}
.Todo {
  border: 2px solid red;
  border-radius: 5px;
  padding: 10px;
  margin: 10px;
  background-color: lightcyan;
}
.submit {
  background-color: chartreuse;
  width: 70px;
  border-radius: 5px;
}
</style>
